'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.main = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var main = exports.main = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var nodeVersion, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, targetArch, local, short, remote;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (process.env.GITHUB_USERNAME) {
              _context.next = 2;
              break;
            }

            throw (0, _log.wasReported)('No github credentials. Upload will fail!');

          case 2:
            _context.t0 = _regenerator2.default.keys(_patches2.default);

          case 3:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 49;
              break;
            }

            nodeVersion = _context.t1.value;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 8;
            _iterator = (0, _getIterator3.default)(_system.targetArchs);

          case 10:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 33;
              break;
            }

            targetArch = _step.value;

            if (!dontBuild(nodeVersion, targetArch)) {
              _context.next = 14;
              break;
            }

            return _context.abrupt('continue', 30);

          case 14:
            local = (0, _places.localPlace)({ from: 'built', arch: targetArch,
              nodeVersion: nodeVersion, platform: _system.hostPlatform, version: _package.version });
            short = _path2.default.basename(local);

            _log.log.info('Building ' + short + '...');
            _context.next = 19;
            return (0, _build2.default)(nodeVersion, targetArch, local);

          case 19:
            _log.log.info('Uploading ' + short + '...');
            remote = (0, _places.remotePlace)({ arch: targetArch,
              nodeVersion: nodeVersion, platform: _system.hostPlatform, version: _package.version });
            _context.prev = 21;
            _context.next = 24;
            return (0, _cloud.upload)(local, remote);

          case 24:
            _context.next = 30;
            break;

          case 26:
            _context.prev = 26;
            _context.t2 = _context['catch'](21);

            // TODO catch only network errors
            _log.log.error(_context.t2);
            _log.log.info('Meanwhile i will continue making binaries');

          case 30:
            _iteratorNormalCompletion = true;
            _context.next = 10;
            break;

          case 33:
            _context.next = 39;
            break;

          case 35:
            _context.prev = 35;
            _context.t3 = _context['catch'](8);
            _didIteratorError = true;
            _iteratorError = _context.t3;

          case 39:
            _context.prev = 39;
            _context.prev = 40;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 42:
            _context.prev = 42;

            if (!_didIteratorError) {
              _context.next = 45;
              break;
            }

            throw _iteratorError;

          case 45:
            return _context.finish(42);

          case 46:
            return _context.finish(39);

          case 47:
            _context.next = 3;
            break;

          case 49:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[8, 35, 39, 47], [21, 26], [40,, 42, 46]]);
  }));

  return function main() {
    return _ref.apply(this, arguments);
  };
}();

var _system = require('./system.js');

var _places = require('./places.js');

var _log = require('./log.js');

var _build = require('./build.js');

var _build2 = _interopRequireDefault(_build);

var _patches = require('../patches/patches.json');

var _patches2 = _interopRequireDefault(_patches);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _cloud = require('./cloud.js');

var _package = require('../package.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function dontBuild(nodeVersion, targetArch) {
  // https://support.apple.com/en-us/HT201948
  // don't disable osx-x86 because it breaks
  // cross-platform tests on x86 hosts
  // TODO disabe osx-x86 again once we have
  // cross-arch compilation
  //  if (hostPlatform === 'osx' &&
  //      targetArch === 'x86') return true;
  // official node 0.12 does not compile on arm
  if (/^v?0/.test(nodeVersion) && /^arm/.test(targetArch)) return true;
  return false;
}

if (!module.parent) {
  main().catch(function (error) {
    if (!error.wasReported) _log.log.error(error);
    process.exit(2);
  });
}